import gnu.regexp.*;
import java.util.*;
public class SemantiqueRule
{

private boolean do_something;
private boolean autour_balise;
private boolean autour_paragraphe;
private boolean autour_document;
private boolean autour_regexp;
private boolean debut_avant;
private boolean fin_avant;
private String  _regexp1;
private String _regexp2;

public SemantiqueRule()
{
do_something=false;
}
public SemantiqueRule(boolean balise,boolean paragraphe,boolean document,boolean regexp,boolean avant1,boolean avant2,String str1,String str2)
{
autour_balise=balise;
autour_paragraphe=paragraphe;
autour_document=document;
autour_regexp=regexp;
debut_avant=avant1;
fin_avant=avant2;
if (autour_regexp) _regexp1=new String(str1);
if (autour_regexp) _regexp2=new String(str2);
}
public void setSomething(boolean something){do_something=something;}
public void setautourBalise(boolean something){autour_balise=something;}
public void setautourParagraphe(boolean something){autour_paragraphe=something;}
public void setautourDocument(boolean something){autour_document=something;}
public void setautourRegExp(boolean regexp) {autour_regexp=regexp;}
public void setAvantDebut(boolean b){debut_avant=b;}
public void setAvantFin(boolean b) {fin_avant=b;}
public void setRegExp1(String regexp){_regexp1=new String(regexp);}
public void setRegExp2(String regexp){_regexp2=new String(regexp);}

public boolean doSomething(){return do_something;}
public boolean autourBalise(){return autour_balise;}
public boolean autourParagraphe(){return autour_paragraphe;}
public boolean autourDocument(){return autour_document;}
public boolean autourRegExp(){return autour_regexp;}
public boolean AvantDebut(){return debut_avant;}
public boolean AvantFin(){return fin_avant;}
public String RegExp1(){return _regexp1;}
public String RegExp2(){return _regexp2;}
public static int getEndRegexp(String regexp,String document,int end,boolean order)
{
try
{RE stub=new RE(regexp,0,RESyntax.RE_SYNTAX_EMACS);
REMatch[] resultat=stub.getAllMatches(document,end);
System.err.println("GETENDREGEXP"+resultat);
int result=-1;
if (resultat.length==0) return result;
int [] resultat_int=new int[resultat.length];

for (int i=0;i<resultat.length;i++)
{

if (order) resultat_int[i]=resultat[i].getStartIndex();
else resultat_int[i]=resultat[i].getEndIndex();
}
Arrays.sort(resultat_int);

return (resultat_int[0]);
}
catch (Exception e){System.err.println(e);return -1;}
}

public static int getBeginRegexp(String regexp,String document,int begin,boolean order)
{
	try{
RE stub=new RE(regexp,0,RESyntax.RE_SYNTAX_EMACS);
REMatch[] resultat=stub.getAllMatches(document);
int result=-1;
if (resultat.length==0) return result;
int taille=0;
for (int j=0;j<resultat.length;j++)
{
if (resultat[j].getStartIndex()<begin && resultat[j].getEndIndex()<=begin) taille++;
}

int [] resultat_int=new int[taille];
int ind=0;
for (int i=0;i<resultat.length;i++)
{
if (resultat[i].getStartIndex()<begin && resultat[i].getEndIndex()<=begin) {

if (order) resultat_int[ind]=resultat[i].getStartIndex();
else resultat_int[ind]=resultat[i].getEndIndex();
ind++;
}
}
Arrays.sort(resultat_int);
return resultat_int[taille-1];
}
catch (Exception e){System.err.println(e);return -1;}
}


}