
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.print.*;
public class Printer extends AbstractAction
{
	
  public static String font= "Monospaced" ;
  public static String fontSize = "10" ;
  public static String lineNumbers = "off" ;
  public static String wrapText ="off" ;
  public static String header ="on" ;
  public static String pageOrientation ="1" ;
  public static String pageWidth ="612" ;
  public static String pageHeight ="792" ;
  public static String pageImgX ="72" ;
  public static String pageImgY ="72" ;
  public static String pageImgWidth ="468" ;
  public static String pageImgHeight ="648" ;
  private MainFrame master;
   public Printer(MainFrame m)
  {
    super("print",new ImageIcon("print.gif"));
  master=m;
  }

  public void actionPerformed(ActionEvent evt)
  {
  
    try
    {
        PrintingOptions printOptions = new PrintingOptions();
        printOptions.setPrintLineNumbers("on".equals(lineNumbers));
        printOptions.setPrintHeader("on".equals(header));
        printOptions.setWrapText("on".equals(wrapText));
        printOptions.setPageFont(new Font(font, 
            Font.PLAIN, (new Integer(fontSize)).intValue()));

        PageFormat pgfmt = new PageFormat();
        Paper paper = pgfmt.getPaper();
        pgfmt.setOrientation((new Integer(pageOrientation)).intValue());
        double width = ((new Double(pageWidth)).doubleValue());
        double height = ((new Double(pageHeight)).doubleValue());
        double imgX = ((new Double(pageImgX)).doubleValue());
        double imgY = ((new Double(pageImgY)).doubleValue());
        double imgWidth = ((new Double(pageImgWidth)).doubleValue());
        double imgHeight = ((new Double(pageImgHeight)).doubleValue());
    
        paper.setSize(width, height);
        paper.setImageableArea(imgX, imgY, imgWidth, imgHeight);
        pgfmt.setPaper(paper);
        printOptions.setPageFormat(pgfmt);
         String s=master.getDocument();
         PlainDocument doc=new PlainDocument();
         doc.insertString(0,  s, new SimpleAttributeSet()) ;
          PrintText print = new PrintText(doc);
  } catch(Exception ioe)
    {
    
    }
    }
 }