import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.BevelBorder;


import javax.swing.border.*;

class StyleEditBalise extends JScrollPane
{
	private ListeBalise _liste_balise;
	protected MainFrame _master;
	private JViewport _window;
	protected FontDialog _fontDialog;
	private Vector _rtflabel;
	protected  BaliseSemantiqueStyle _balisesemantiquestyle;
	public static String default_dtd="Default.dtd";
class RTFLabel 
{
private Balise balise;
private FontDialog fd;
private NTextField _textfield;
class RTFLabelListener extends AbstractAction
{
private Balise ba;
private NTextField rtflab;
private FontDialog fd;
public RTFLabelListener(NTextField rtflabel,FontDialog f,Balise b)
{
super("Changer les attributs de la balise "+b.getName(),new ImageIcon(new String("icons"+System.getProperty("file.separator")+"stylebalise.gif")));
ba=b;
rtflab=rtflabel;
fd=f;
}
public  void actionPerformed(ActionEvent e) 
  
{try
{
fd.set_example(ba.getName(),ba.getAttribut());
fd.setAttributes(ba.getAttribut());
fd.setVisible(true);
if (fd.getStatus()==JOptionPane.OK_OPTION) ba.UpDateAttribut(fd.getAttributes());
_master.UpDateTag();
StyledDocument d=rtflab.getStyledDocument();
d.setCharacterAttributes(0,d.getLength(), ba.getAttribut(), false);
}
catch (Exception ee) {System.out.println(ee);}
}
}
class SemLabelListener extends AbstractAction
{
private Balise ba;

private BaliseSemantiqueStyle fd;
public SemLabelListener(BaliseSemantiqueStyle f,Balise b)
{
super("Changer les attributs de la balise "+b.getName(),new ImageIcon(new String("icons"+System.getProperty("file.separator")+"sembalise.gif")));
ba=b;
fd=f;
}
public  void actionPerformed(ActionEvent e) 
           
{
/*try
{
fd.set_example(ba.getName(),ba.getAttribut());
fd.setAttributes(ba.getAttribut());
fd.setVisible(true);
if (fd.getStatus()==JOptionPane.OK_OPTION) ba.UpDateAttribut(fd.getAttributes());
_master.UpDateTag();
StyledDocument d=rtflab.getStyledDocument();
d.setCharacterAttributes(0,d.getLength(), ba.getAttribut(), false);
}
catch (Exception ee) {System.out.println(ee);}}*/
System.err.println("RULE:"+ba.getRule());
fd.setAttributes(ba.getRule());
fd.setVisible(true);
if (fd.getStatus()==JOptionPane.OK_OPTION)
{
SemantiqueRule rule=ba.getRule();
boolean something=fd.getDoSomething();
rule.setSomething(something);
System.err.println("GetDOSomething():"+ba.getName()+" vlaue "+something);
if (something)
	{
	rule.setautourBalise(fd.getArroundBalise());
	rule.setautourParagraphe(fd.getArroundParagraphe());
	rule.setautourDocument(fd.getArroundDocument());
	boolean b=fd.getArroundRegexp();
	rule.setautourRegExp(b);
	if (b)
		{
		rule.setAvantDebut(fd.getAvantDebut());
		rule.setAvantFin(fd.getAvantFin());
		rule.setRegExp1(fd.getRegExp1());
		rule.setRegExp2(fd.getRegExp2());
		}
}
else {
     rule.setautourBalise(false);
	rule.setautourParagraphe(false);
	rule.setautourDocument(false);
	rule.setautourRegExp(false);
	     }
}
}          
}
public class NTextField extends JTextPane  implements MouseListener
{
protected Balise _balise;
protected MainFrame _master;
  protected Border m_raised;
  protected Border m_lowered;
  protected Border m_inactive;
  protected boolean _actif;
public NTextField(Balise balise,MainFrame master)
{
super();
_balise=balise;
_master=master;
  m_raised = new BevelBorder(BevelBorder.RAISED);
    m_lowered = new BevelBorder(BevelBorder.LOWERED);
    m_inactive = new EmptyBorder(2, 2, 2, 2);
    
 setBorder(m_inactive);
 addMouseListener(this);
    setRequestFocusEnabled(false);
  _actif=true;
 
}
public void setActif(boolean actif)
{
_actif=actif;
if (!_actif) setBackground(new Color(255,0,0));
else setBackground(new Color(255,255,255));
}
public void setActif(Vector v)
{
String name=_balise.getName();
if (!v.contains(name)) setActif(false);
}
public void mouseClicked(MouseEvent e){
      
System.out.println("StyleEditBalise::mouseClicked");
if (_actif) _master.UpDateChild(_balise,_balise.getAttribut());

   
}
        public void mousePressed(MouseEvent e) {
   if (_actif) setBorder(m_lowered);
  }
/** met a jour le bord inactif du bouton 
 * si la souris est releve
 */
  public void mouseReleased(MouseEvent e) {
 if (_actif)   setBorder(m_inactive);
  }

  /** a surcharge , effet si le bouton est clicke
   */
 
  public void mouseEntered(MouseEvent e) {
 if (_actif)   setBorder(m_raised);
  }

  public void mouseExited(MouseEvent e) {
  if (_actif)  setBorder(m_inactive);
  }


}
public RTFLabel(Balise b,FontDialog _fd,MainFrame master,JPanel p_action,JPanel p_font,JPanel p_sem,BaliseSemantiqueStyle sem)
{
_textfield=new NTextField(b,master);
StyledEditorKit m_kit = new StyledEditorKit();
 _textfield.setEditorKit(m_kit);
balise=b;
fd=_fd;

_textfield.setDocument(new DefaultStyledDocument(new StyleContext()));
_textfield.setDoubleBuffered(true);
_textfield.setEditable(false);
try
{_textfield.getDocument().insertString(0,b.toString(),b.getAttribut());
}catch (Exception f) {System.out.println(f);}
SmallButton sb=new SmallButton(new RTFLabelListener(_textfield,fd,b),"Changer les attributs");

sb.setSize(32,32);
SmallButton sb2=new SmallButton(new SemLabelListener(sem,b),"Changer les attributs semantique");
sb2.setSize(32,32);

p_action.add(_textfield);

p_font.add(sb);
p_sem.add(sb2);

}
public void setActif(boolean actif) {_textfield.setActif(actif);}
public void setActif(Vector v ) {_textfield.setActif(v);}

}	
public void GereDefault()
{	try
	{FileReader fichier=new FileReader(StyleEditBalise.default_dtd);
	
	String filename=new String();
	int c=0;
	char [] v=new char[1];
	while((c=fichier.read())!=-1)
	{
	v[0]=(char)c;
	filename=filename.concat(new String(v));
	
}
	fichier.close();
	_master.LectDTD(filename);}
	catch (Exception b){};
}
public StyleEditBalise(MainFrame master)
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	      _master=master;
	setSize(600, 400);
	_window=new JViewport();
setViewportView(_window);	
 String []  m_fontNames = GraphicsEnvironment.
      getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
   String []  m_fontSizes = new  String[] {"8", "9", "10", "11", "12", "14",
      "16", "18", "20", "22", "24", "26", "28", "36", "48", "72"};
	 _fontDialog=new FontDialog(master);
	 _balisesemantiquestyle=new BaliseSemantiqueStyle(master);
	 _fontDialog.init(m_fontNames,m_fontSizes);
	 _rtflabel=new Vector(10,10);
	 setVisible(true);


	 
}
public void initDefaultColorDialog(Vector v)
{
 String []  m_fontNames = GraphicsEnvironment.
      getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
   String []  m_fontSizes = new  String[] {"8", "9", "10", "11", "12", "14",
      "16", "18", "20", "22", "24", "26", "28", "36", "48", "72"};
 _fontDialog=new FontDialog(_master);
_fontDialog.initDefaultColorDialog(v);
_fontDialog.init(m_fontNames,m_fontSizes);
}
public Vector GetDefaultColor()
{
return _fontDialog.GetDefaultColor();
}
public void UpDate(ListeBalise liste_balise)
{
System.out.println(liste_balise);
JPanel checking = new JPanel(new BorderLayout());
JPanel p_name = new JPanel(new GridLayout(liste_balise.size(), 1, 10, 2));
JPanel p_action = new JPanel(new GridLayout(liste_balise.size(), 1, 10, 2));
JPanel p_sem = new JPanel(new GridLayout(liste_balise.size(), 1, 10, 2));

checking.setBorder(new TitledBorder(new EtchedBorder(), "Style des Balises"));
for (int j=0;j<liste_balise.size();j++) 
{
	Balise b=(Balise)liste_balise.get(j);
	RTFLabel label=new RTFLabel(b,_fontDialog,_master,p_name,p_action,p_sem,_balisesemantiquestyle);
	_rtflabel.add(label);
	
}
checking.add(p_name, BorderLayout.WEST);
checking.add(p_action,BorderLayout.CENTER);
checking.add(p_sem,BorderLayout.EAST);
_window.add(checking);
  
  setVisible(false);
  setVisible(true);
}
public void Activ(Vector s)
{
for (int i=0;i<_rtflabel.size();i++) 
{
((RTFLabel)_rtflabel.get(i)).setActif(s);
}
}
public void ActivAll(boolean b)
{
for (int i=0;i<_rtflabel.size();i++) 
{
((RTFLabel)_rtflabel.get(i)).setActif(b);
}
}
public void Activate(Balise b){}
}
