import java.util.Vector;
/**
 * La classe XmlNode sert a la generation du document XML<br>
 * Elle represente un tableau de Balise Node 
 * ordonne en fonction de leur apparition dans le texte
 */
public class XmlNode
{


private BaliseNode [] _node;

public XmlNode()
{}
private void swap(Object [] tab,int index1,int index2)
{
Object tmp=tab[index1];
tab[index1]=tab[index2];
tab[index2]=tmp;
}
private BaliseNode[] sort(BaliseNode[] bnode)
{
int taille=bnode.length;
boolean change=true;
while(change)
{
change=false;
for (int i=0;i<taille-1;i++)
{
if (bnode[i].getIndex()>bnode[i+1].getIndex()) {swap(bnode,i,i+1);change=true;}
}
}

return (bnode);
}

private BaliseNode[] sort2(BaliseNode[] bnode)
{
int taille=bnode.length;
boolean change=true;
while(change)
{
change=false;
for (int i=0;i<taille-1;i++)
{
if (bnode[i].getIndex()<bnode[i+1].getIndex()) {swap(bnode,i,i+1);change=true;}
}
}

return (bnode);
}
/**
 * renvoie le tableau de balise node ordonne
 */
public BaliseNode[] getNode(){return _node;}
/**
 * initialise l'objet avec la liste des tag 
 * et cree le tableau de balise node
 */
 private int whereis (BaliseNode [] tab,BaliseNode node)
 {
 for (int i=0;i<tab.length;i++)
 if (tab[i].equals(node)) return i;
 return 0;
 }
public void Init(ListeTag tag)
{
int taile=tag.size();
BaliseNode un;
BaliseNode deux;
Tag t;
_node=new BaliseNode[taile*2];
int in=0;
for (int i=0;i<taile;i++)
{
t=tag.get(i);
un=new BaliseNode(t,true);
deux=new BaliseNode(t,false);
un.SetSoeur(deux);
deux.SetSoeur(un);
_node[in++]=un;
_node[in++]=deux;
}
BaliseNode[] toCheck=sort(_node);
//BaliseNode[] toCheck2=sort2(_node);

int taille =toCheck.length;
int index=0;
boolean change=true;

while(change)
{change=false;
for (index=0;index<(taille-1);index++)
{
	if (toCheck[index].getIndex()==toCheck[index+1].getIndex()
	  && toCheck[index].getSoeur().getIndex()!=toCheck[index+1].getSoeur().getIndex())
	{
		if (toCheck[index].IsDebut() && toCheck[index+1].IsDebut())
		{
		if (toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex())
		{System.out.println("condition1 On Swappe "+index+" et "+(index+1)+" condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		swap(toCheck,index,index+1);change=true;
		System.out.println("apres swap condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		}
	}
		else
		if (!toCheck[index].IsDebut() && !toCheck[index+1].IsDebut())
		{
		if (toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex())
		{System.out.println("condition 2 On Swappe "+index+" et "+(index+1)+" condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		swap(toCheck,index,index+1);change=true;
		System.out.println("apres swap condition "+(toCheck[index].getSoeur().getIndex()<toCheck[index+1].getSoeur().getIndex()));
		}
		else 
		if (toCheck[index].IsDebut() && !toCheck[index+1].IsDebut())
		{System.out.println("condition 3 On Swappe "+index+" et "+(index+1));
		swap(toCheck,index,index+1);change=true;
		}
	}
		
	}
	

}

change=true;
while(change)
{
	change=false;
	for (index=0;index<(taille-1);index++)
	{
	if (toCheck[index].getIndex()==toCheck[index+1].getIndex()
		  && toCheck[index].getSoeur().getIndex()==toCheck[index+1].getSoeur().getIndex())
		  {
		   if (toCheck[index].IsDebut() 
			   && toCheck[index+1].IsDebut()
			   && !toCheck[index].getSoeur().IsDebut()
			   && !toCheck[index+1].getSoeur().IsDebut())
			   //est t on dans un monde merdique 
			   {
			   int m1=0;
			     for (m1=0;m1<_node.length;m1++) if (toCheck[m1].equals(toCheck[index].getSoeur())) break;
			     int m2=0;
			     for (m2=0;m1<_node.length;m2++) if (toCheck[m2].equals(toCheck[index+1].getSoeur())) break;
			 if (m2>m1) // et oui
				     {
				      if (_node[index].getTag().getBalise().getOrder()
				       > _node[index+1].getTag().getBalise().getOrder())
				        { 
				  // a la lecture de la dtd il semblerait qu'il faille inverser
				         swap(toCheck,index,index+1);change=true;}
				         else 	{swap(toCheck,m1,m2);change=true;}
				     }
			   }
		  }
	}
}

}
_node=toCheck;

}


public ListeTag toListeTag()
{
int taille=_node.length;
ListeTag result=new ListeTag();
for (int i=0;i<taille;i++)
{
if (_node[i].IsDebut()) result.add(_node[i].getTag());
}
return result;

}
public String toString()
{
String result=new String();
for (int i=0;i<_node.length;i++)
{
result=result+","+_node[i].toString();
}
return result;
}


}
